# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from .. import utilities, tables

class VpnGatewayRoutePropagation(pulumi.CustomResource):
    route_table_id: pulumi.Output[str]
    """
    The id of the `aws_route_table` to propagate routes into.
    """
    vpn_gateway_id: pulumi.Output[str]
    """
    The id of the `aws_vpn_gateway` to propagate routes from.
    """
    def __init__(__self__, resource_name, opts=None, route_table_id=None, vpn_gateway_id=None, __name__=None, __opts__=None):
        """
        Requests automatic route propagation between a VPN gateway and a route table.
        
        > **Note:** This resource should not be used with a route table that has
        the `propagating_vgws` argument set. If that argument is set, any route
        propagation not explicitly listed in its value will be removed.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] route_table_id: The id of the `aws_route_table` to propagate routes into.
        :param pulumi.Input[str] vpn_gateway_id: The id of the `aws_vpn_gateway` to propagate routes from.

        > This content is derived from https://github.com/terraform-providers/terraform-provider-aws/blob/master/website/docs/r/vpn_gateway_route_propagation.html.markdown.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if route_table_id is None:
            raise TypeError("Missing required property 'route_table_id'")
        __props__['route_table_id'] = route_table_id

        if vpn_gateway_id is None:
            raise TypeError("Missing required property 'vpn_gateway_id'")
        __props__['vpn_gateway_id'] = vpn_gateway_id

        super(VpnGatewayRoutePropagation, __self__).__init__(
            'aws:ec2/vpnGatewayRoutePropagation:VpnGatewayRoutePropagation',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

